# dot

This repo tracks user and system configuration files, installed packages
and initial command history for setting-up a desktop environment running Debian
testing/unstable with `sway`, `foot`, `fuzzel` and `neovim`.

## bootstrap the dotfiles

```
sudo apt install git
git init -b main
git remote add origin gitea@git.kompot.si:urosm/dot.git
git pull origin main
```

## setup urosm@milano

```sh
# disable the annoying `.sudo_as_admin_successful` file
sudo cp -ri .config/sudoers.d /etc/
rm .sudo_as_admin_successful
# update to debian testing
sudo cp -ri .config/apt /etc/
sudo apt update
sudo apt full-upgrade
# configure and start firewall
sudo cp -ri .config/nftables.conf /etc/
systemctl enable --now nftables
# configure and install networking
sudo apt install network-manager
# install utils
sudo apt install git
sudo apt install udevil
sudo apt install jq
sudo apt install tlp
sudo apt install neovim wl-clipboard
# install desktop packages
sudo apt install sway swayidle swaylock
sudo apt install fuzzel
sudo apt install brightnessctl wlsunset grim
sudo apt install mako-notifier libnotify-bin
sudo apt install fonts-agave
sudo apt install pipewire-audio
systemctl --user enable --now wireplumber
# install web packages
sudo apt install firefox
sudo apt install thunderbird
# install office packages
sudo apt install libreoffice libreoffice-gtk3
sudo apt install aspell-sl hunspell-sl hyphen-sl mythes-sl
# install media packages
sudo apt install mpv
sudo apt install zathura
sudo apt install inkscape
sudo apt install blender
sudo apt install scribus
# install rdp packages
sudo apt install remmina
# install printing and scanning packages
sudo apt install cups printer-driver-all
sudo adduser urosm lpadmin
sudo apt install simple-scan
# install writing packages
sudo apt install make
sudo apt install pandoc
#sudo apt install texlive-latex-extra
#sudo apt install texlive-lang-european
# install pdf processing packages
#sudo apt install qpdf ocrmypdf
```
